Temporary CI workaround for RT#92226
[dbsrgits/DBIx-Class.git] / maint / travis-ci_scripts / common.bash
CommitLineData
b58ecb01 1#!/bin/bash
2
3set -e
4
b9970637 5TEST_STDERR_LOG=/tmp/dbictest.stderr
851b6c2d 6TIMEOUT_CMD="/usr/bin/timeout --kill-after=9.5m --signal=TERM 9m"
b9970637 7
b58ecb01 8echo_err() { echo "$@" 1>&2 ; }
9
10if [[ "$TRAVIS" != "true" ]] ; then
11 echo_err "Running this script makes no sense outside of travis-ci"
12 exit 1
13fi
14
15tstamp() { echo -n "[$(date '+%H:%M:%S')]" ; }
16
17run_or_err() {
18 echo_err -n "$(tstamp) $1 ... "
19
20 LASTEXIT=0
21 START_TIME=$SECONDS
003e97c5 22 # the tee is a handy debugging tool when stumpage is exceedingly strong
23 #LASTOUT=$( bash -c "$2" 2>&1 | tee /dev/stderr) || LASTEXIT=$?
b58ecb01 24 LASTOUT=$( bash -c "$2" 2>&1 ) || LASTEXIT=$?
25 DELTA_TIME=$(( $SECONDS - $START_TIME ))
26
27 if [[ "$LASTEXIT" != "0" ]] ; then
4242985f 28 echo_err "FAILED !!! (after ${DELTA_TIME}s)"
29 echo_err "Command executed:"
30 echo_err "$2"
31 echo_err "STDOUT+STDERR:"
32 echo_err "$LASTOUT"
33
b58ecb01 34 return $LASTEXIT
35 else
36 echo_err "done (took ${DELTA_TIME}s)"
37 fi
38}
39
003e97c5 40apt_install() {
41 # flatten
42 pkgs="$@"
43
44 # Need to do this at every step, the sources list may very well have changed
45 run_or_err "Updating APT available package list" "sudo apt-get update"
46
47 run_or_err "Installing Debian APT packages: $pkgs" "sudo apt-get install --allow-unauthenticated --no-install-recommends -y $pkgs"
48}
49
b58ecb01 50extract_prereqs() {
71dd2ecc 51 # once --verbose is set, --no-verbose can't disable it
52 # do this by hand
b2435630 53 local PERL_CPANM_OPT="$( echo $PERL_CPANM_OPT | sed 's/--verbose\s*//' )"
71dd2ecc 54
b58ecb01 55 # hack-hack-hack
56 LASTEXIT=0
57 COMBINED_OUT="$( { stdout="$(cpanm --quiet --scandeps --format tree "$@")" ; } 2>&1; echo "!!!STDERRSTDOUTSEPARATOR!!!$stdout")" \
58 || LASTEXIT=$?
59
60 OUT=${COMBINED_OUT#*!!!STDERRSTDOUTSEPARATOR!!!}
61 ERR=$(grep -v " is up to date." <<< "${COMBINED_OUT%!!!STDERRSTDOUTSEPARATOR!!!*}")
62
50e644e5 63 if [[ "$LASTEXIT" != "0" ]] ; then
4242985f 64 echo_err "Error occured (exit code $LASTEXIT) retrieving dependencies of $@:"
65 echo_err "$ERR"
66 echo_err "$OUT"
b58ecb01 67 exit 1
68 fi
69
8fe19930 70 # throw away warnings, ascii art, convert to modnames
71 PQ=$(perl -p -e 's/^\!.*//; s/^[^a-z]+//i; s/\-[^\-]+$/ /; s/\-/::/g' <<< "$OUT")
f207111d 72
73 # throw away what was in $@
74 for m in "$@" ; do
75 PQ=$( perl -p -e 's/(?:\s|^)\Q'"$m"'\E(?:\s|$)/ /mg' <<< "$PQ")
76 done
77
78 # RV
79 echo "$PQ"
b58ecb01 80}
81
82parallel_installdeps_notest() {
83 if [[ -z "$@" ]] ; then return; fi
84
4242985f 85 # one module spec per line
86 MODLIST="$(printf '%s\n' "$@")"
b58ecb01 87
88 # The reason we do things so "non-interactively" is that xargs -P will have the
89 # latest cpanm instance overwrite the buildlog. There seems to be no way to
90 # specify a custom buildlog, hence we just collect the verbose output
10e248bf 91 # and display it in case of "worker" failure
92 #
93 # Explanation of inline args:
94 #
95 # [09:38] <T> you need a $0
96 # [09:38] <G> hence the _
97 # [09:38] <G> bash -c '...' _
98 # [09:39] <T> I like -- because it's the magic that gnu getopts uses for somethign else
99 # [09:39] <G> or --, yes
100 # [09:39] <T> ribasushi: you could put "giant space monkey penises" instead of "--" and it would work just as well
101 #
4242985f 102 run_or_err "Installing (without testing) $(echo $MODLIST)" \
103 "echo \\
104\"$MODLIST\" \\
105 | xargs -d '\\n' -n 1 -P $NUMTHREADS bash -c \\
e6b373aa 106 'OUT=\$($TIMEOUT_CMD cpanm --notest \"\$@\" 2>&1 ) || (LASTEXIT=\$?; echo \"\$OUT\"; exit \$LASTEXIT)' \\
4242985f 107 'giant space monkey penises'
10e248bf 108 "
b58ecb01 109}
110
579472df 111installdeps() {
112 if [[ -z "$@" ]] ; then return; fi
113
114 echo_err "$(tstamp) Processing dependencies: $@"
115
116 local -x HARNESS_OPTIONS
117
118 HARNESS_OPTIONS="j$NUMTHREADS"
119
120 echo_err -n "Attempting install of $# modules under parallel ($HARNESS_OPTIONS) testing ... "
121
122 LASTEXIT=0
123 START_TIME=$SECONDS
e6b373aa 124 LASTOUT=$( _dep_inst_with_test "$@" ) || LASTEXIT=$?
579472df 125 DELTA_TIME=$(( $SECONDS - $START_TIME ))
126
127 if [[ "$LASTEXIT" = "0" ]] ; then
128 echo_err "done (took ${DELTA_TIME}s)"
129 else
e6b373aa 130 local errlog="after ${DELTA_TIME}s Exit:$LASTEXIT Log:$(/usr/bin/nopaste -q -s Shadowcat -d "Parallel testfail" <<< "$LASTOUT")"
a9fc70ee 131 echo_err -n "failed ($errlog) retrying with sequential testing ... "
132 POSTMORTEM="$POSTMORTEM$(
133 echo
77a86bbf 134 echo "Depinstall under $HARNESS_OPTIONS parallel testing failed $errlog"
135 echo "============================================================="
136 echo "Attempted installation of: $@"
137 echo "============================================================="
a9fc70ee 138 )"
579472df 139
140 HARNESS_OPTIONS=""
141 LASTEXIT=0
142 START_TIME=$SECONDS
e6b373aa 143 LASTOUT=$( _dep_inst_with_test "$@" ) || LASTEXIT=$?
579472df 144 DELTA_TIME=$(( $SECONDS - $START_TIME ))
145
146 if [[ "$LASTEXIT" = "0" ]] ; then
147 echo_err "done (took ${DELTA_TIME}s)"
148 else
149 echo_err "FAILED !!! (after ${DELTA_TIME}s)"
150 echo_err "STDOUT+STDERR:"
151 echo_err "$LASTOUT"
152 exit 1
153 fi
154 fi
155
156 INSTALLDEPS_OUT="${INSTALLDEPS_OUT}${LASTOUT}"
157}
158
e6b373aa 159_dep_inst_with_test() {
160 if [[ "$DEVREL_DEPS" == "true" ]] ; then
161 # --dev is already part of CPANM_OPT
162 $TIMEOUT_CMD cpanm "$@" 2>&1
163 else
164 $TIMEOUT_CMD cpan "$@" 2>&1
579472df 165
e6b373aa 166 # older perls do not have a CPAN which can exit with error on failed install
167 for m in "$@"; do
168 if ! perl -e '
579472df 169
647da28e 170my $mod = (
579472df 171 $ARGV[0] =~ m{ \/ .*? ([^\/]+) $ }x
172 ? do { my @p = split (/\-/, $1); pop @p; join "::", @p }
173 : $ARGV[0]
647da28e 174);
175
176$mod = q{List::Util} if $mod eq q{Scalar::List::Utils};
177
178eval qq{require($mod)} or ( print $@ and exit 1)
579472df 179
e6b373aa 180 ' "$m" 2> /dev/null ; then
181 echo -e "$m installation seems to have failed"
182 return 1
183 fi
184 done
185 fi
579472df 186}
187
b58ecb01 188CPAN_is_sane() { perl -MCPAN\ 1.94_56 -e 1 &>/dev/null ; }
f207111d 189
190CPAN_supports_BUILDPL() { perl -MCPAN\ 1.9205 -e1 &>/dev/null; }